#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll INF = 1e18;

struct ArrivalTime {
    ll time;
    ll os_count;
    ll r_count;
    ll ex_count;
};

int main() {
    ll train_count, os_travel_time, r_travel_time, ex_travel_time;
    cin >> train_count >> os_travel_time >> r_travel_time >> ex_travel_time;

    vector<ArrivalTime> arrival_times;
    arrival_times.push_back({-INF, 0, 0, 0});

    for (ll i = 0; i < train_count; i++) {
        ll arrival_time; char type[3];
        cin >> arrival_time >> type;

        if (arrival_times.back().time < arrival_time) {
            auto [_, os_count, r_count, ex_count] = arrival_times.back();
            arrival_times.push_back({arrival_time, os_count, r_count, ex_count});
        }

        if (strcmp(type, "Os") == 0) {
            arrival_times.back().os_count += 1;
        } else if (strcmp(type, "R") == 0) {
            arrival_times.back().r_count += 1;
        } else if (strcmp(type, "Ex") == 0) {
            arrival_times.back().ex_count += 1;
        }
    }

    // dp[os][r] - arrival_times[os].time = maximální čas odjezdu posledního Os, arrival_times[r].time = maximální čas odjezdu posledního R
    vector<vector<ll>> dp(arrival_times.size(), vector<ll>(arrival_times.size(), INF));
    dp[0][0] = 0;

    for (int i = 1; i < arrival_times.size(); i++) {
        
        // Zpoždění čekajících vlaků
        for (int os = 0; os < i; os++) {
            for (int r = 0; r < i; r++) {
                ll waiting_train_count = arrival_times[i - 1].os_count - arrival_times[os].os_count;
                waiting_train_count += arrival_times[i - 1].r_count - arrival_times[r].r_count;
                dp[os][r] += waiting_train_count * (arrival_times[i].time - arrival_times[i - 1].time);
            }
        }


        // zpoždění Ex
        for (int os = 0; os <= i; os++) {
            for (int r = 0; r <= i; r++) {
                ll last_train_finish_time = max(arrival_times[os].time + os_travel_time, arrival_times[r].time + r_travel_time);
                ll ex_trains_delay = max(0LL, last_train_finish_time - (arrival_times[i].time + ex_travel_time));
                dp[os][r] += (arrival_times[i].ex_count - arrival_times[i - 1].ex_count) * ex_trains_delay;
            }
        }

        // zpoždění R
        for (int os = 0; os <= i; os++) {
            for (int r = 0; r < i; r++) {
                ll last_train_finish_time = max(0LL, arrival_times[os].time + os_travel_time);
                ll r_trains_delay = max(0LL, last_train_finish_time - (arrival_times[i].time + r_travel_time));
                ll r_depart_count = arrival_times[i].r_count - arrival_times[r].r_count;
                dp[os][i] = min(dp[os][i], dp[os][r] + r_depart_count * r_trains_delay);
            }
        }

        // zpzpoždění Os
        for (int os = 0; os < i; os++) {
            for (int r = 0; r <= i; r++) {
                dp[i][r] = min(dp[i][r], dp[os][r]);
            }
        }
    }

    cout << dp[arrival_times.size() - 1][arrival_times.size() - 1] << endl;
}