#include <bits/stdc++.h>
// Časová složitost: o(n!)

#ifdef GUDEB
    #define D(x) cerr << #x << ": " << (x) << '\n';
    #define ifdeb if(true)
#else
    #define D(x) ;
    #define ifdeb if(false)
#endif

#define all(x) begin(x), end(x)

using namespace std;
using ull = unsigned long long;
using ll = long long;
// #define int ll;

enum TS : char {
    Os = 0,
    R = 1,
    Ex = 2,
};

struct Train {
    int a;
    TS t;
};

int n;
int tt[3];

constexpr double TEMP_START = 10;
constexpr double TEMP_END = 10e-3;
constexpr double TEMP_MUL = 0.999999;

ll sim(vector<Train>& ts) {
    int d = 0;
    int a = 0;
    ll del = 0;
    for(int i = 0; i < n; ++i) {
        d = max(d, ts[i].a);
        a = max(a, d + tt[ts[i].t]);
        del += a - (ts[i].a + tt[ts[i].t]);
    }
    return del;
}

void solve() {
    cin >> n;
    cin >> tt[0] >> tt[1] >> tt[2];

    srand(9953);

    vector<Train> ts(n);
    for(int i = 0; i < n; ++i) {
        int t;
        string c;
        cin >> t >> c;
        TS v = Os;
        if(c[0] == 'O') v = Os;
        if(c[0] == 'R') v = R;
        if(c[0] == 'E') v = Ex;
        ts[i] = {t, v};
    }


    ll cdel = sim(ts);
    ll best = cdel;
    for(double t = TEMP_START; t > TEMP_END; t *= TEMP_MUL) {
        int p1 = rand() % n;
        int p2 = rand() % (n-1);
        if(p2 >= p1) ++p2;
        swap(ts[p1], ts[p2]);
        ll del = sim(ts);
        ll dif = del - cdel;
        if(dif < 0 || exp(-1.0*dif/t) >= (1.0*rand()/RAND_MAX)) {
            cdel = del;
        } else {
            swap(ts[p1], ts[p2]);
        }
        best = min(best, cdel);
    }

    cout << best << '\n';
    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}

