#include <bits/stdc++.h>
// Časová složitost: O(n^3)

#ifdef GUDEB
    #define D(x) cerr << #x << ": " << (x) << '\n';
    #define ifdeb if(true)
#else
    #define D(x) ;
    #define ifdeb if(false)
#endif

#define all(x) begin(x), end(x)

using namespace std;
using ull = unsigned long long;
using ll = long long;
// #define int ll;

enum TS : char {
    Os = 0,
    R = 1,
    Ex = 2,
};

struct Train {
    int a;
    TS t;
};

int n;
ll dp[1000][1000];

void solve() {
    cin >> n;
    vector<Train> ts(n);
    int tt[3];
    cin >> tt[0] >> tt[1] >> tt[2];

    for(int i = 0; i < n; ++i) {
        int t;
        string c;
        cin >> t >> c;
        TS v = Os;
        if(c[0] == 'O') v = Os;
        if(c[0] == 'R') v = R;
        if(c[0] == 'E') v = Ex;
        ts[i] = {t, v};
    }

    vector<int> bt[3];

    bt[Os].push_back(-tt[Os]);
    bt[R ].push_back(-tt[R ]);
    bt[Ex].push_back(-tt[Ex]);

    for(int i = 0; i < n; ++i) {
        bt[ts[i].t].push_back(ts[i].a);
    }
    int done[3] = {0};

    for(int i = 0; i < n; ++i) {
        auto [start, tp] = ts[i];

        // add the train
        if(tp == Ex) {
            for(int o = 0; o <= done[Os]; ++o) {
                for(int r = 0; r <= done[R]; ++r) {
                    int end = max({bt[Os][done[Os] - o] + tt[Os],
                                   bt[R ][done[R ] - r] + tt[R ],
                                   bt[Ex][done[Ex]    ] + tt[Ex]});
                    int del = max(0, end - (start + tt[Ex]));
                    dp[o][r] += del;
                }
            }
        } else if(tp == R) {
            for(int o = done[Os]; o >= 0; --o) {
                for(int r = done[R]; r >= 0 ; --r) {
                    dp[o][r+1] = dp[o][r];
                }
                dp[o][0] = 1e18;
            }
        } else if(tp == Os) {
            for(int o = done[Os]; o >= 0; --o) {
                for(int r = done[R]; r >= 0 ; --r) {
                    dp[o+1][r] = dp[o][r];
                }
            }
            for(int r = done[R]; r >= 0 ; --r) {
                dp[0][r] = 1e18;
            }
        }
        done[tp] += 1;

        // release the rychlíks!
        for(int o = 0; o <= done[Os]; ++o) {
            for(int r = 1; r <= done[R]; ++r) {
                int end = max({bt[Os][done[Os] - o] + tt[Os],
                               bt[R ][done[R ] - r] + tt[R ],
                               bt[Ex][done[Ex]    ] + tt[Ex]});
                int del = r*max(0, end - (start + tt[R]));
                dp[o][0] = min(dp[o][0], dp[o][r] + del);
            }
        }

        // release the osobáks!
        for(int o = 0; o <= done[Os]; ++o) {
            int end = max({bt[Os][done[Os] - o] + tt[Os],
                           bt[R ][done[R ]    ] + tt[R ],
                           bt[Ex][done[Ex]    ] + tt[Ex]});
            int del = o*max(0, end - (start + tt[Os]));
            dp[0][0] = min(dp[0][0], dp[o][0] + del);
        }

        // add delays!
        if(i != n-1) {
            int new_st = ts[i+1].a;
            int delta = new_st - start;
            for(int o = 0; o <= done[Os]; ++o) {
                for(int r = 0; r <= done[R]; ++r) {
                    dp[o][r] += 1ll*(o+r)*delta;
                }
            }
        }
    }

    cout << dp[0][0] << '\n';
    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}

