#include <bits/stdc++.h>
// Časová složitost: O(n^3)

#ifdef GUDEB
    #define D(x) cerr << #x << ": " << (x) << '\n';
    #define ifdeb if(true)
#else
    #define D(x) ;
    #define ifdeb if(false)
#endif

#define all(x) begin(x), end(x)

using namespace std;
using ull = unsigned long long;
using ll = long long;
// #define int ll;

enum TS : char {
    Os = 0,
    R = 1,
    Ex = 2,
};

struct Train {
    int a;
    TS t;
};

int n;
ll dp[1001][1001];

void solve() {
    cin >> n;
    vector<Train> ts(n);
    int tt[3];
    cin >> tt[0] >> tt[1] >> tt[2];

    vector<int> times;
    times.reserve(n+1);
    times.push_back(-tt[0]);

    for(int i = 0; i < n; ++i) {
        int a;
        string c;
        cin >> a >> c;
        TS t = Os;
        if(c[0] == 'O') t = Os;
        if(c[0] == 'R') t = R;
        if(c[0] == 'E') t = Ex;
        ts[i] = {a, t};
        times.push_back(a);
    }

    int done[1001][3] = {0};

    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < 3; ++j) {
            done[i+1][j] = done[i][j];
        }
        done[i+1][ts[i].t] += 1;
    }

    int lastex = -tt[Ex];
    for(int i = 0; i < n; ++i) {
        auto [start, tp] = ts[i];

        // add the train
        if(tp == Ex) {
            for(int r = 0; r <= i; ++r) {
                for(int o = 0; o <= r; ++o) {
                    int end = max({times[o] + tt[Os],
                                   times[r] + tt[R ],
                                   lastex   + tt[Ex]});
                    int del = max(0, end - (start + tt[Ex]));
                    dp[r][o] += del;
                }
            }
            lastex = start;
        }

        for(int o = 0; o <= i+1; ++o) {
            dp[i+1][o] = 1e18;
        }

        // release the rychlíks!
        for(int r = 0; r <= i; ++r) {
            for(int o = 0; o <= r; ++o) {
                int end = max({times[o] + tt[Os],
                               times[r] + tt[R ],
                               lastex  + tt[Ex]});
                int del = max(0, end - (start + tt[R]));
                dp[i+1][o] = min(dp[i+1][o], dp[r][o] + del);
            }
        }

        // release the osobáks!
        for(int o = 0; o <= i; ++o) {
            int end = max({times[o] + tt[Os],
                           times[i] + tt[R ],
                           lastex  + tt[Ex]});
            int del = max(0, end - (start + tt[Os]));
            dp[i+1][i+1] = min(dp[i+1][i+1], dp[i+1][o] + del);
        }

        // add delays!
        if(i != n-1) {
            int new_st = ts[i+1].a;
            int delta = new_st - start;
            for(int r = 0; r <= i+1; ++r) {
                for(int o = 0; o <= r; ++o) {
                    dp[r][o] += 1ll*(done[i+1][R] + done[i+1][Os] - done[r][R] - done[o][Os])*delta;
                }
            }
        }
    }

    cout << dp[n][n] << '\n';
    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}

